#!/bin/bash

PREBOOT_VER="1.5.4.45"
PREBOOT_MTD="/dev/mtd0"
PREBOOT_SIZE=250112
PREBOOT_OUTPUT_NAME="bl1.img"
PREBOOT_PATH="`pwd`/$PREBOOT_OUTPUT_NAME"

FIRMWARE_NAME="1.5.5(FSTEC)"
FIRMWARE_BUILD=2
FIRMWARE_VER="/etc/version"

check_mtd() {
	input_count=`grep -a "$PREBOOT_VER" $PREBOOT_MTD | wc -l`
	if [[ $input_count != 2 ]]; then
		echo "Invalid preboot loaded"
		exit 1
	fi
}

get_preboot() {
	check_mtd
	dd ibs=1 count=$PREBOOT_SIZE iflag=count_bytes if=$PREBOOT_MTD of=$PREBOOT_PATH
}

check_firmware() {
	if [[ `head -1 $FIRMWARE_VER` != "$FIRMWARE_NAME" ]]; then
		echo "Invalid firmware loaded"
		exit 1
	fi

	if [[ `head -2 $FIRMWARE_VER | tail -1` != $FIRMWARE_BUILD ]]; then
		echo "Invalid firmware loaded"
		exit 1
	fi
}

echo "Extract preboot to $PREBOOT_PATH . . ."
check_firmware
get_preboot
echo "Done"
